<template>
    <v-container fluid>
        <ValidationObserver ref="observer" slim>
            <v-row>
                <v-col cols="12">
                    <div class="field-label">{{ $t('label') }}</div>
                    <ValidationProvider vid="label" name="label" rules="required" v-slot="{ errors }">
                        <v-text-field
                            dense
                            outlined
                            hide-details="auto"
                            v-model="label"
                            :loading="loading"
                            :error-messages="errors"
                        ></v-text-field>
                    </ValidationProvider>
                </v-col>
                <v-col>
                    <div class="field-label">{{ $t('from') }}</div>
                    <ValidationProvider vid="from" name="from" rules="required" v-slot="{ errors }">
                        <v-menu
                            ref="fromPicker"
                            :close-on-content-click="false"
                            :nudge-right="40"
                            transition="scale-transition"
                            offset-y
                            min-width="290px"
                        >
                            <template v-slot:activator="{ on, attrs }">
                                <v-text-field
                                    v-model="from"
                                    :loading="loading"
                                    :error-messages="errors"
                                    prepend-inner-icon="mdi-calendar"
                                    hide-details="auto"
                                    v-bind="attrs"
                                    v-on="on"
                                    readonly
                                    dense
                                    outlined
                                ></v-text-field>
                            </template>
                            <v-date-picker
                                v-model="from"
                                @input="$refs.fromPicker.save(from)"
                            ></v-date-picker>
                        </v-menu>
                    </ValidationProvider>
                </v-col>
                <v-col>
                    <div class="field-label">{{ $t('to') }}</div>
                    <ValidationProvider vid="to" name="to" rules="required" v-slot="{ errors }">
                        <v-menu
                            ref="toPicker"
                            :close-on-content-click="false"
                            :nudge-right="40"
                            transition="scale-transition"
                            offset-y
                            min-width="290px"
                        >
                            <template v-slot:activator="{ on, attrs }">
                                <v-text-field
                                    v-model="to"
                                    :loading="loading"
                                    :error-messages="errors"
                                    prepend-inner-icon="mdi-calendar"
                                    hide-details="auto"
                                    v-bind="attrs"
                                    v-on="on"
                                    readonly
                                    dense
                                    outlined
                                ></v-text-field>
                            </template>
                            <v-date-picker
                                v-model="to"
                                @input="$refs.toPicker.save(to)"
                            ></v-date-picker>
                        </v-menu>
                    </ValidationProvider>
                </v-col>
                <v-col cols="12" class="text-center">
                    <v-btn
                        color="primary"
                        :loading="loading"
                        @click="onClick"
                    >
                        {{ isEditMode ? $t('save') : $t('create') }}
                    </v-btn>
                </v-col>
            </v-row>
        </ValidationObserver>
    </v-container>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from "vee-validate";

    export default {
        name: "HolidayForm",
        components: {
            ValidationObserver,
            ValidationProvider
        },
        props: {
            value: {
                type: Object,
                default: () => ({})
            },
            loading: {
                type: Boolean,
                default: false
            },
            errors: {
                type: [Array, Object],
                default: () => []
            },
            mode: {
                type: String,
                default: 'create',
                validator: value => ['create', 'edit'].indexOf(value) !== -1
            }
        },
        data: () => ({
            label: null,
            from: null,
            to: null
        }),
        computed: {
            isEditMode() {
                return this.mode === 'edit'
            }
        },
        watch: {
            errors(val) {
                if(val) {
                    this.$refs.observer.setErrors(val)
                }
            }
        },
        created() {
            if(this.isEditMode) {
                this.label = this.value.label
                this.from = this.value.from
                this.to = this.value.to
            }
        },
        methods: {
            async onClick() {
                const valid = await this.$refs.observer.validate()

                if(valid) {
                    this.$emit('validated', {
                        label: this.label,
                        from: this.from,
                        to: this.to
                    })
                }
            }
        }
    }
</script>

<style scoped>

</style>
